#!/usr/bin/env python
# Semplice script per l'inserimento in massa di utenti
#
# Copyright (C) 2006 Simone Piccardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


import getopt, sys, random, string
from os import *

def usage():
    print "Usage: insertuser.py [-h] [-f file] [-r home] [-p pass | -g]"
    print "                     userlist"
    print "       -h        print this help"
    print "       -g NN     generate random passwords values NN char long"
    print "       -p pass   set pass as password for each user "
    print "       -P        set pass reading the optional field on the list "
    print "       -f file   dump user list and password to file file"
    print "       -r home   use home as root for home directories"
    print
    print "the userlist file must contains the user list, the format is:"
    print "   Name Surname, username, [password,] group1, group2, ..."
    print "with a line for each user."
    

# option parsing
try:
    opts, args = getopt.getopt(sys.argv[1:], 'f:r:p:g:Ph')
    optval={}
    for opt, val in opts:
        if opt == "-h":
            usage()
            sys.exit(0)
        else:
            optval[opt]=val

except getopt.GetoptError:
    usage()
    sys.exit(2)

# check password option, only one can used
count = 0
for i in ['-g', '-p', '-P']:
    if optval.has_key(i):
        count = count+1
if count > 1:
    print "Password setting option must be one between -g, -p and -P"
    usage()
    sys.exit(2)

# check arguments, only the user list file must be present
if len(args) !=1:
    usage()
    sys.exit(0)

# open dump file
if optval.has_key('-f'):
    dumpfile = file(optval['-f'],'w')
    dumpfile.write("Nome e Cognome\t\tUsername\t\tPassword\n")


# open user list file 
userfile = file(args[0])
users = userfile.readlines()

# loop on user list
for user in users:
    values = user.strip('\n').split(',')
    name = values.pop(0).strip()
    username = values.pop(0).strip()
    # setting password according to the choosen option
    if optval.has_key('-p'):   passwd = optval['-p']
    elif optval.has_key('-P'): passwd = values.pop(0).strip()
    elif optval.has_key('-g'):
        size = int(optval['-g'])
        chars = string.letters + string.digits
        passwd = ''
        for i in range(size):
            passwd += random.choice(chars)

    groups = ",".join(values).replace(' ','')

    print name, username, passwd, groups

    command = "smbldap-useradd -a -m -B1 -G \"%s\" -c \"%s\" -N \"%s\" %s" % (groups, name, name, username)
    print "comando ", command
    system(command)
    pipe = popen("smbldap-passwd %s" % username, "w")
    pipe.write("%s\n" % passwd)
    pipe.write("%s\n" % passwd)
    pipe.close()

    dumpfile.write("%s\t\t%s\t\t%s\n" % (name,username,passwd))
  
